
// VU METER EXAMPLE
// Aug. 31, 2005, C. Feldbauer

#include "blocks.h"
#include "dsk6713_led.h"


#define MASK4 0x7000
#define MASK3 0x7e00
#define MASK2 0x7fc0
#define MASK1 0x7ff8

void init( void)
{
  DSK6713_LED_init();
}

void processing( void * buffer)
{
  short *workbuf = buffer; // only to get correct pointer type
  int i,ledcnt=0;
  
  for(i=0; i<BLKSZ; i++)
  {
    if( workbuf[i] > 0)
    {
      if( workbuf[i] & MASK4)
      {
        ledcnt=4;
        break;
      }
      else
      {
        if( workbuf[i] & MASK3)
        {
          if(ledcnt<3) ledcnt = 3;
        }
        else
        {
          if( workbuf[i] & MASK2)
          {
            if(ledcnt<2) ledcnt = 2;
          }
          else
          {
            if( workbuf[i] & MASK1)
            {
             if(ledcnt<1) ledcnt = 1;
            }
          }
        }
      }
    }
  }
  
  for(i=0; i<ledcnt; i++) DSK6713_LED_on(i);
  for(   ; i<4     ; i++) DSK6713_LED_off(i);
}
